#!/usr/sbin/dtrace -s
/*
 * functime.d: Can be used to figure out time spent in each function.
 *
 * Usage:      Specify the name of the executable for "Script Arags"
 *             parameter in the DTrace configuration table.
 *             Specify the absolute path name to the executable for the
 *             "Executable" parameter and so on.
 *
 * Copyright 2007 Sun Microsystems, Inc.,
 * 4150 Network Circle, Santa Clara,
 * California 95054, U.S.A. All rights reserved.
 */
pid$target:$1::entry
{
   self->ts[probefunc] = timestamp;
}

pid$target:$1::return
/self->ts[probefunc]/
{
   @func_time[probefunc] = sum(timestamp - self->ts[probefunc]);
   self->ts[probefunc] = 0;
}
