/*
 * CDDL HEADER START
 *
 * The contents of this file are subject to the terms of the
 * Common Development and Distribution License (the "License").
 * You may not use this file except in compliance with the License.
 *
 * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
 * or http://www.opensolaris.org/os/licensing.
 * See the License for the specific language governing permissions
 * and limitations under the License.
 *
 * When distributing Covered Code, include this CDDL HEADER in each
 * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
 * If applicable, add the following below this CDDL HEADER, with the
 * fields enclosed by brackets "[]" replaced with your own identifying
 * information: Portions Copyright [yyyy] [name of copyright owner]
 *
 * CDDL HEADER END
 */

/*
 * Copyright 2007 Sun Microsystems, Inc.  All rights reserved.
 * Use is subject to license terms.
 */

#pragma ident	"@(#)method_times.d	1.1	07/12/21 SMI"

hotspot$target:::method-entry
{
	self->timestamp = timestamp;

	/* signature */
	self->str_ptr = (char*)copyin(arg5, arg6 + 1);
	self->str_ptr[arg6] = '\0';
	self->signature = (string)self->str_ptr;

	/* method name */
	self->str_ptr = (char*)copyin(arg3, arg4 + 1);
	self->str_ptr[arg4] = '\0';
	self->method_name = strjoin((string)self->str_ptr, self->signature);

	/* class name */
	self->str_ptr = (char*)copyin(arg1, arg2 + 2);
	self->str_ptr[arg2] = '.';
	self->str_ptr[arg2 + 1] = '\0';
	self->method = strjoin((string)self->str_ptr, self->method_name);
}

hotspot$target:::method-return
/ self->timestamp /
{
	@method_times[self->method] = sum(timestamp - self->timestamp);
	self->timestamp = 0;

	self->str_ptr = 0;
	self->class_name = 0;
	self->method_name = 0;
	self->signature = 0;
}
